#ifndef __crc__
#define __crc__

#define crc16 bt_crc16
#define crc32 bt_crc32

extern void crc16 ( short *crc16p, unsigned char *buffer, int bufsize );
extern void crc32 ( int *crc32p, unsigned char *buffer, int bufsize );
extern unsigned long bt_adler32 ( unsigned long adler, unsigned char *buf, unsigned int len );

#if 0 
typedef struct
{
  unsigned long state[5];
  unsigned long count[2];
  unsigned char buffer[64];
} SHS_INFO;


void shsHash( char *data, unsigned int len, unsigned char digest[20] );
void shsInit( SHS_INFO *context );
void shsUpdate( SHS_INFO *context, unsigned char *data, unsigned int len );
void shsFinal( unsigned char digest[20], SHS_INFO *context );
void shsTransform( unsigned long state[5], unsigned char buffer[64] );

extern void sha_copy ( struct sha_ctx * dest, struct sha_ctx * src );
extern void sha_init ( struct sha_ctx * ctx );
extern void sha_transform ( unsigned int * state, unsigned int * data );
extern void sha_update ( struct sha_ctx * ctx, const unsigned char * buffer, unsigned int len );
extern void sha_final ( struct sha_ctx * ctx );
extern void sha_digest ( struct sha_ctx * ctx, unsigned char * s );

#endif

/* The SHA block size and message digest sizes, in bytes */

# define UINT32 unsigned int
# define UINT16 unsigned short
# define UINT8 unsigned char

#define SHA_DATASIZE    64
#define SHA_DATALEN     16
#define SHA_DIGESTSIZE  20
#define SHA_DIGESTLEN    5
/* The structure for storing SHA info */

struct sha_ctx {
  UINT32 digest[SHA_DIGESTLEN];  /* Message digest */
  UINT32 count_l, count_h;       /* 64-bit block count */
  UINT8 block[SHA_DATASIZE];     /* SHA data buffer */
  int index;                     /* index into buffer */
};

void sha_init(struct sha_ctx *ctx);
void sha_update(struct sha_ctx *ctx, const UINT8 *buffer, UINT32 len);
void sha_final(struct sha_ctx *ctx);
void sha_digest(struct sha_ctx *ctx, UINT8 *s);
void sha_copy(struct sha_ctx *dest, struct sha_ctx *src);

/* The core compression function, mapping 5 + 16 32-bit words to 5
 * words. Destroys the data in the process. */
void sha_transform(UINT32 *state, UINT32 *data);



#endif
